package dev.shadowsoffire.apotheosis.adventure.affix.reforging;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingMenu;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingRecipe;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableTile;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.util.ApothMiscUtil;
import dev.shadowsoffire.placebo.util.EnchantmentUtils;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.SlotItemHandler;
import org.jetbrains.annotations.NotNull;

public class ReforgingResultSlot extends SlotItemHandler {
  public ReforgingResultSlot(IItemHandler itemHandler, int index, int xPosition, int yPosition) {
    super(itemHandler, index, xPosition, yPosition);
  }
  
  public boolean m_5857_(@NotNull ItemStack stack) {
    return false;
  }
  
  public boolean m_8010_(Player playerIn) {
    ItemStack input = ReforgingMenu.this.m_38853_(0).m_7993_();
    LootRarity rarity = ReforgingMenu.this.getRarity();
    ReforgingRecipe recipe = ((ReforgingTableTile)ReforgingMenu.access$000(ReforgingMenu.this)).getRecipeFor(rarity);
    if (recipe == null || input.m_41619_())
      return false; 
    int sigils = ReforgingMenu.this.getSigilCount();
    int sigilCost = ReforgingMenu.this.getSigilCost(getSlotIndex());
    int mats = ReforgingMenu.this.getMatCount();
    int matCost = ReforgingMenu.this.getMatCost(getSlotIndex());
    int levels = ReforgingMenu.this.player.f_36078_;
    int levelCost = ReforgingMenu.this.getLevelCost(getSlotIndex());
    if ((sigils < sigilCost || mats < matCost || levels < levelCost) && !ReforgingMenu.this.player.m_7500_())
      return false; 
    return super.m_8010_(playerIn);
  }
  
  public void m_142406_(Player player, ItemStack stack) {
    if (!(player.m_9236_()).f_46443_) {
      ReforgingMenu.this.m_38853_(0).m_5852_(ItemStack.f_41583_);
      if (!player.m_7500_()) {
        int sigilCost = ReforgingMenu.this.getSigilCost(getSlotIndex());
        int matCost = ReforgingMenu.this.getMatCost(getSlotIndex());
        int levelCost = ReforgingMenu.this.getLevelCost(getSlotIndex());
        ReforgingMenu.this.m_38853_(1).m_7993_().m_41774_(matCost);
        ReforgingMenu.this.m_38853_(2).m_7993_().m_41774_(sigilCost);
        EnchantmentUtils.chargeExperience(player, ApothMiscUtil.getExpCostForSlot(levelCost, getSlotIndex()));
      } 
      player.getPersistentData().m_128405_("apoth_reforge_seed", player.f_19796_.m_188502_());
      ReforgingMenu.this.updateSeed();
    } 
    player.m_5496_(SoundEvents.f_11862_, 0.99F, (player.m_9236_()).f_46441_.m_188501_() * 0.25F + 1.0F);
    player.m_5496_(SoundEvents.f_144054_, 0.34F, (player.m_9236_()).f_46441_.m_188501_() * 0.2F + 0.8F);
    player.m_5496_(SoundEvents.f_12471_, 0.45F, (player.m_9236_()).f_46441_.m_188501_() * 0.5F + 0.75F);
  }
}
